<?php 

/* ------------------------------------------------------------------------
 * B2J Contact for Joomla 3.0+
 * ------------------------------------------------------------------------
 * Copyright (C) 2015 Codextrous. All Rights Reserved.
 * Fork of Fox Contact by Fox Joomla Extensions
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: Codextrous
 * Websites: http://www.codextrous.com
  ------------------------------------------------------------------------
 */

defined('_JEXEC') or die('Restricted access');

	$inc_dir = realpath(dirname(__FILE__));
	require_once($inc_dir . '/b2jdispatcher.php');

	class B2JAdminMailer extends B2JDispatcher
	{

		public function __construct(&$params, B2JMessageBoard &$messageboard, &$fieldsbuilder)
		{
			parent::__construct($params, $messageboard, $fieldsbuilder);
		}


		protected function LoadFields()
		{
		}


		public function Process()
		{
			$mail = JFactory::getMailer();

			$this->set_from($mail);
			$this->set_to($mail, "to_address", "addRecipient");
			$this->set_to($mail, "cc_address", "addCC");
			$this->set_to($mail, "bcc_address", "addBCC");
			$mail->setSubject(JMailHelper::cleanSubject($this->Params->get("email_subject", "")));

			$body = $this->body();
			$body .= $this->attachments($mail);
			$body .= "<br/>";

			$body .= $this->Application->getCfg("sitename") . " - " . $this->CurrentURL() . "<br/>";

			$body .= "Client: " . $this->ClientIPaddress() . " - " . $_SERVER['HTTP_USER_AGENT'] . "<br/>";

			$body = JMailHelper::cleanBody($body);
			$mail->setBody($body);
			$mail->isHTML(true);

			$this->Logger->Write("---------------------------------------------------" . "<br/>" . $body);
			return $this->send($mail);
		}


		private function set_from(&$mail)
		{
			$email_sender_submitter = $this->Params->get('email_sender_submitter', 0);
			$adminemailreplyto = array();
			$replayTo = array();
			$adminemailreplyto['0'] = $this->Application->getCfg("mailfrom");
			$adminemailreplyto['1'] = $this->Application->getCfg("fromname");
			$replayTo['0'] = $adminemailreplyto['0'];
			
			if ($email_sender_submitter == 1 && 
				(isset($this->FieldsBuilder->senderEmail->b2jFieldValue) || !empty($this->FieldsBuilder->senderEmail->b2jFieldValue))){
				$adminemailreplyto['0'] = $this->FieldsBuilder->senderEmail->b2jFieldValue;
				$adminemailreplyto['1'] = $this->FieldsBuilder->senderEmail->b2jFieldValue;	
				$replayTo['0'] = $this->FieldsBuilder->senderEmail->b2jFieldValue;
			}
			
			$mail->setSender($adminemailreplyto);
			$mail->ClearReplyTos();
			$mail->addReplyTo(array($replayTo['0']));
		}


		private function set_to(&$mail, $param_name, $method)
		{
			if ($this->Params->get($param_name, NULL))
				$recipients = explode(",", $this->Params->get($param_name, ""));
			else
				$recipients = array();

			foreach ($recipients as $recipient)
			{
				if (empty($recipient)) continue;
				$mail->$method($recipient);
			}
		}


		protected function attachments(&$mail)
		{
			$result = "";
			$uploadmethod = intval($this->Params->get("uploadmethod", "1")); 

			if (count($this->FileList) && ($uploadmethod & 1)) $result .= JText::_($GLOBALS["COM_NAME"] . "_ATTACHMENTS") . "<br/>";
			foreach ($this->FileList as &$file)
			{
				$filename = 'components/' . $GLOBALS["com_name"] . '/uploads/' . $file;
				if ($uploadmethod & 1) $result .= JUri::base() . $filename . "<br/>";
				if ($uploadmethod & 2) $mail->addAttachment(JPATH_SITE . "/" . $filename);
			}

			return $result;
		}
		
		protected function body()
		{
			$result = "";
			$email_body = $this->Params->get('email_body', '');
			
			if (empty($email_body)){
				return parent::body();
			}
			
			$tokens  = $this->prepareToken();
			$result .= $this->replaceToken($email_body, $tokens);
			$result .= "<br/>";
			return $result;
		}
		
		protected function prepareToken()
		{
			$tokens = array();
			foreach ($this->FieldsBuilder->DynamicFields as $key => $field)
			{
				if($field[0]->state != 0){
					foreach ($field[1] as $dynamicfield){
						$fieldName = JFilterInput::getInstance()->clean($dynamicfield->b2jFieldName, "");
						$fieldValue = JFilterInput::getInstance()->clean($dynamicfield->b2jFieldValue, "");
						$tokens[$fieldName] = $fieldValue;
					}
				}
			}
			
			return $tokens;
		}

		protected function replaceToken($content, $tokens)
		{	
			if (empty($tokens)){	
				return $content;
			}

			foreach($tokens as $key => $value){
				if(!is_array($value)){
					$content = str_replace('[['.$key.']]', $value, $content);
					//$content =  preg_replace('/\[\['.$key.'\]\]/', $value, $content);
				}
			}
			return $content;
		}		

	}
?>