<?php 

/* ------------------------------------------------------------------------
 * B2J Contact for Joomla 3.0+
 * ------------------------------------------------------------------------
 * Copyright (C) 2015 Codextrous. All Rights Reserved.
 * Fork of Fox Contact by Fox Joomla Extensions
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: Codextrous
 * Websites: http://www.codextrous.com
  ------------------------------------------------------------------------
 */

defined('_JEXEC') or die('Restricted access');

$inc_dir = realpath(dirname(__FILE__));
require_once($inc_dir . '/b2jdatapump.php');
require_once($inc_dir . '/b2jlogger.php');

class B2JDomainrestrict extends B2JDataPump
{
	protected $FieldsBuilder;


	public function __construct(&$params, B2JMessageBoard &$messageboard, $fieldsbuilder)
	{
		parent::__construct($params, $messageboard);

		$this->Name = "B2JDomainrestrict";
		$this->FieldsBuilder = $fieldsbuilder;
		$this->isvalid = intval($this->ValidateEmailDomain($fieldsbuilder));
	}


	public function Show()
	{
		if (!$this->isvalid)
		{
			$this->MessageBoard->Add($this->Params->get("restricted_domain_message"), B2JMessageBoard::warning);
		}
	}


	protected function LoadFields()
	{
	}


	protected function ValidateEmailDomain(&$fieldsbuilder)
	{
		$email = "";

		foreach ($fieldsbuilder->DynamicFields as $Fields)
        {
        	foreach ($Fields[1] as $field) {
        		if (strpos($field->type, "b2jDynamicEmail") !== 0) continue;
        		$email = $field->b2jFieldValue;
        		break;
        	}
        } 

		$restricted_domains = $this->Params->get("restricted_domain", "");
		if (empty($restricted_domains) || empty($email)) return true;

		
		$arr_restricted_domains = explode(",", $restricted_domains);

		list ($user, $domain) = explode('@', $email);
		
		if (in_array($domain, $arr_restricted_domains)){
			$logger = new B2JLogger();
			$logger->Write("Form submission restricted from domain:" . PHP_EOL . print_r($fieldsbuilder->Fields, true) . "-----------------------------------------");
			return false;
		}
		
		return true;
	}
}

?>
