<?php 

/* ------------------------------------------------------------------------
 * B2J Contact for Joomla 3.0+
 * ------------------------------------------------------------------------
 * Copyright (C) 2015 Codextrous. All Rights Reserved.
 * Fork of Fox Contact by Fox Joomla Extensions
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: Codextrous
 * Websites: http://www.codextrous.com
  ------------------------------------------------------------------------
 */

defined('_JEXEC') or die('Restricted access');

	$inc_dir = realpath(dirname(__FILE__));
	require_once($inc_dir . '/b2jdispatcher.php');

	class B2JSubmitterMailer extends B2JDispatcher
	{

		public function __construct(&$params, B2JMessageBoard &$messageboard, &$fieldsbuilder)
		{
			parent::__construct($params, $messageboard, $fieldsbuilder);
		}


		protected function LoadFields()
		{
		}


		public function Process()
		{
			$copy_to_submitter =
			(bool)JFactory::getApplication()->input->post->get($this->SafeName("copy_to_submitter" . $this->GetId()), NULL, 'string') || 
			($this->Params->get("copy_to_submitter", NULL) == 1); 

			if (!$copy_to_submitter || !isset($this->FieldsBuilder->senderEmail->b2jFieldValue) || empty($this->FieldsBuilder->senderEmail->b2jFieldValue))
			{
				$this->B2JSession->Clear('filelist');

				return true;
			}

			$mail = JFactory::getMailer();

			$mail->isHTML(true);
			
			$this->set_from($mail);
			$this->set_to($mail);
			$mail->setSubject(JMailHelper::cleanSubject($this->Params->get("email_copy_subject", "")));
			$body = $this->body();
			$mail->setBody($body);
			
			$this->B2JSession->Clear('filelist');

			$this->send($mail);
			return true;
		}

		protected function body()
		{
			$result = "";
			$email_body = $this->Params->get('email_copy_text', '');
			
			if (empty($email_body)){
				return parent::body();
			}
			
			$tokens  = $this->prepareToken();
			$result .= $this->replaceToken($email_body, $tokens);
			$result .= "<br/>";
			
			if ($this->Params->get("email_copy_summary", NULL)){
				$result .= parent::body();
				$result .= "<br/>";
				$result .= $this->attachments();
				$result .= "<br/>";
			}
			$result .= JText::_('COM_B2JCONTACT_SUBMITTER_MAILER_PREPEND_STRING'). "<br/>" . $this->Application->getCfg("sitename") . "<br/>";
			$result = JMailHelper::cleanBody($result);
			return $result;
		}

		private function set_from(&$mail)
		{
			$emailhelper = new B2jEmailHelper($this->Params);
			$config = JComponentHelper::getParams("com_b2jcontact");

			$submitteremailfrom = $config->get("submitteremailfrom");
			$from = $emailhelper->convert($submitteremailfrom);
			$mail->setSender($from);

			$application = JFactory::getApplication();
			$name = $application->getCfg("fromname");

			if ($this->Params->get("to_address", NULL)){
				$replytoAddresses = explode(",", $this->Params->get('to_address', ""));
			}else{
				$replytoAddresses = array();
			}

			foreach ($replytoAddresses as $replytoAddress)
			{
				if (empty($replytoAddress)) continue;
				$replytoMail = $replytoAddress;
				break;
			}

			$replyto['0'] = $replytoMail;
			$replyto['1'] = $name; 	

			$mail->ClearReplyTos();
			$mail->addReplyTo(array($replyto['0']), $replyto['1']);
		}


		private function set_to(&$mail)
		{
			//$addr = $this->FieldsBuilder->Fields['sender1']['Value'];
			$addr =$this->FieldsBuilder->senderEmail->b2jFieldValue;
			$mail->addRecipient(JMailHelper::cleanAddress($addr));
		}


		protected function attachments()
		{
			$result = "";


			if (count($this->FileList)) $result .= JText::_($GLOBALS["COM_NAME"] . "_ATTACHMENTS") . "<br/>";
			foreach ($this->FileList as &$file)
			{
				$result .= substr($file, 14) . "<br/>";
			}

			return $result;
		}
		
		protected function prepareToken()
		{
			$tokens = array();
			foreach ($this->FieldsBuilder->DynamicFields as $key => $field)
			{
				if($field[0]->state != 0){
					foreach ($field[1] as $dynamicfield){
						$fieldName = JFilterInput::getInstance()->clean($dynamicfield->b2jFieldName, "");
						$fieldValue = JFilterInput::getInstance()->clean($dynamicfield->b2jFieldValue, "");
						$tokens[$fieldName] = $fieldValue;
					}
				}
			}
			
			return $tokens;
		}

		protected function replaceToken($content, $tokens)
		{	
			if (empty($tokens)){	
				return $content;
			}

			foreach($tokens as $key => $value){
				if(!is_array($value)){
					$content = str_replace('[['.$key.']]', $value, $content);
					//$content =  preg_replace('/\[\['.$key.'\]\]/', $value, $content);
				}
			}
			return $content;
		}

	}
?>